bunch of minor updates
[automated-distro-installer] / myfai-chboot-local
index 49ee6f6efcb6c9ce9ad67d7f30fee83fab3f35c7..1845cd02d58c6c98114f3eaf4987e01cb1e699e3 100755 (executable)
@@ -1,40 +1,50 @@
 #!/bin/bash
-
 # note, this script gets piped to bash, so cant cd to current dir
+
+[[ $EUID == 0 ]] || exec sudo "${BASH_SOURCE}" "$@"
+
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
+kgped16=false
 fai_action=install
 fai_reboot_arg=,reboot
-case $1 in
-  -h|--help)
-    echo "see help from myfai-chboot"
-    exit 0
-    ;;
-  -S)
-    fai_action=sysinfo
-    fai_reboot_arg=
-    shift
-    ;;
-  -i) #inventory
-    fai_action=inventory
-    fai_reboot_arg=
-    shift
-    ;;
-esac
-
-[[ $EUID == 0 ]] || exec sudo "${BASH_SOURCE}" "$@"
+while [[ $1 == -* ]]; do
+  case $1 in
+    -h|--help)
+      echo "see help from myfai-chboot"
+      exit 0
+      ;;
+    -S)
+      fai_action=sysinfo
+      fai_reboot_arg=
+      shift
+      ;;
+    -i) #inventory
+      fai_action=inventory
+      fai_reboot_arg=
+      shift
+      ;;
+    -k)
+      kgped16=true;
+      shift
+      ;;
+  esac
+done
 
-e() {
-  echo "$*"
-  if ! "$@"; then
-    echo "$0: error: exit code $? from: $*"
-    exit 1
-  fi
-}
+pre="${0##*/}:"
+m() { printf "$pre %s\n"  "$*"; "$@"; }
+e() { printf "$pre %s\n"  "$*"; }
+err() { echo "[$(date +'%Y-%m-%d %H:%M:%S%z')]: $pre: $*" >&2; }
 
 host=$1
 
+rm -f /srv/tftp/fai/pxelinux.cfg/*
+if [[ ! $1 ]]; then
+  echo "$0: clearing pxe config and exiting"
+  exit 0
+fi
+
 # assuming ipv4, or else we might need to deal with multiple addresses
 # in an ipv4 + ipv6 network.
 my_ip=$(ip -4 route get 8.8.8.8 | sed -nr 's,^.*src\s+(\S+).*,\1,p')
@@ -55,6 +65,7 @@ else
     exit 1
   fi
   ip=$ip/32
+  echo "$0: found ip of $host: $ip"
 fi
 
 if modprobe nfsd &>/dev/null; then
@@ -71,7 +82,7 @@ if modprobe nfsd &>/dev/null; then
   if [[ -w /etc/exports ]]; then
     sed -ri --follow-symlinks '\%^/srv/fai/%d' /etc/exports
     cat >>/etc/exports <<EOF
-/srv/fai/config $ip(async,ro,no_subtree_check)
+/srv/fai/config $ip(async,ro,no_subtree_check,no_root_squash)
 /srv/fai/nfsroot $ip(async,ro,no_subtree_check,no_root_squash)
 EOF
     exportfs -ra
@@ -88,22 +99,22 @@ else
 EOF
 fi
 
-rm -f /srv/tftp/fai/pxelinux.cfg/*
-if [[ ! $1 ]]; then
-  exit 0
-fi
 
 
 # man page doesn't explain this, but this deletes & thus disables
 # all chboot systems.
-e fai-chboot -iv $std_arg default # set it to default to get a val out of it next
+m fai-chboot -iv $std_arg default # set it to default to get a val out of it next
 kernel=$(fai-chboot -L '^default$' | awk '{print $3}')
 default_k_args=$(fai-chboot -L '^default$' | \
                    sed -r "s/^(\S+\s+){3}(.*)/\2/")
 # example of default_k_args
 # initrd=initrd.img-3.16.0-4-amd64 ip=dhcp root=192.168.1.3:/srv/fai/nfsroot aufs FAI_CONFIG_SRC=nfs://faiserver/srv/fai/config FAI_ACTION=install
 
-k_args=(console=tty0 console=ttyS0,115200 FAI_ACTION=$fai_action)
+k_args=(FAI_ACTION=$fai_action)
+if $kgped16; then
+  k_args+=(console=tty0 console=ttyS0,115200)
+fi
+
 for arg in $default_k_args; do
   case $arg in
     # default root arg is /srv/fai/nfsroot
@@ -112,7 +123,7 @@ for arg in $default_k_args; do
   esac
 done
 rm -f /srv/tftp/fai/pxelinux.cfg/*
-e fai-chboot -k "${k_args[*]}" -v -f verbose,sshd,createvt$fai_reboot_arg $std_arg $kernel "$host"
+m fai-chboot -k "${k_args[*]}" -v -f verbose,sshd,createvt$fai_reboot_arg $std_arg $kernel "$host"
 
 # this is needed for autodiscover iso. i'm not sure, it might override
 # the fai-chboot method of setting this, i'm not sure.